#!/usr/bin/env ruby

require 'pstore'
require 'nkf'

html = false
if ARGV[0] == '-h'
  html = true
  ARGV.shift
end

target = ARGV[0] ? ARGV[0] : "html/phobos"
dbname = ARGV[1] ? ARGV[1] : 'dref.db'

if File.exists?(dbname)
  File.unlink(dbname)
end
db=PStore.new(dbname)
db.transaction do
  Dir.glob("#{target}/*.html").each do |filename|
    cur = mod = filename[/#{target}\/(\w+).html/, 1].tr('_', '.').sub(/std./, '')
    db[mod] = "The #{mod} module."
    open(filename) do |f|
      c = f.read
      c.scan(/<dt>(<big>.*?<\/big>)<\/dt>[^<]*<dd>(.*?)(?=(<\/dd>|<dl><dt>))/m) do
        pm = $`
        nm = $'
        title, body = [$1, $2].map{|$_|NKF.nkf('-We', gsub('<br>', "\n").strip)}
        nest = (nm =~ /\A<dl><dt>/)
        if pm =~ /<\/dl>[\r\n]*<\/dd>\Z/m
          cur = mod
        end
        if (title =~ /<big>([^<]+)<u>([^<]+)<\/u>/ ||
            title =~ /<big>()(this)/ ||
            title =~ /<big>()<u>([^<]+)<\/u>/)
          name = $2
          fqn = (mod==cur) || nest ? "#{mod}.#{name}" : "#{mod}.#{cur}.#{name}"
          p "#{$1}#{cur}.#{$2}"
          desc = "#{title}\n\n#{body}"
          desc.gsub!(/<[^>]+>/, '').gsub(/[\r\n][\r\n]+/m, "\n\n") if !html
          db[fqn] = desc
          if nest
            cur = name
          end
        else
          raise title
        end
      end
    end
  end
end
